<?php
abstract class AbstractEntity
{


	protected $uid;
	protected $meta;
	protected static $entities = array();
	protected $config;
	protected $xml_parser;

	protected function __construct($config) {
		/*
		if (self::exists($uid)) {
			trigger_error('Redeclaring category: ' . $uid, E_USER_ERROR);
		}
		*/
		$this->config = $config;
	}

	public static function exists($uid) {
		return isset(self::$entities[$uid]);
	}

	public static function get($uid) {
		return self::$entities[$uid];
	}

	public static function get_all() {
		return self::$entities;
	}

	protected function get_uid() {
		return $this->uid;
	}

	public function get_metadata() {
		return $this->meta;
	}

	public function get_metadata_value($name, $lang = null) {
		if (!is_array($this->meta[$name])) {
			return $this->meta[$name];
		}
		if ($lang === null) {
			$lang = $this->config−>get('site', 'default_language');
		}
		if (isset($this->meta[$name][$lang])) {
			return $this->meta[$name][$lang];
		} else {
			return $this->meta[$name][$this->config->get('site', 'default_language')];
		}
	}

	abstract protected function get_url();
	abstract protected function load($xml_file);
	abstract public function generate($lang, $smarty);

}

?>
