<?php
abstract class URLHelper
{

	private static $config;

	public static function init($config) {
		self::$config = $config;
	}

	public static function clean($url)
	{
		$newurl = '';
		for ($i=0; $i<strlen($url); $i++)
		{
			if (!($i>8 && $url[$i] =='/' && $url[$i-1]=='/'))
			{
				$newurl .= $url[$i];
			}
		}
		return $newurl;
		return $url;
	}

	public static function get_entity_url($entity, $uid, $lang = null) {
		if ($lang === null) {
			$lang = self::$config->get('site', 'default_language');
		}
		switch ($entity) {
			case 'page':
				return EntityPage::get($uid)->get_url();
			break;

			case 'category':
				return EntityCategory::get($uid)->get_url();
			break;

			case 'tag':
				return EntityTag::get($uid)->get_url();
			break;

			default:
				trigger_error('Unknown entity type: ' . $entity, E_USER_ERROR);
			break;
		}
	}

	public static function get_icon_url($img, $size=32)
	{
		if (!is_numeric($size))
		{
			return self::clean('//' . self::$config->get('site', 'root_url') . '/' . self::$config->get('urls', 'icons') . '/' . $size . '/' . $img . '.png');
		}
		else
		{
			return self::clean('//' . self::$config->get('site', 'root_url') . '/' . self::$config->get('urls', 'icons') . '/' . $img . $size . 'x' . $size . '.png');
		}
	}

	public static function get_external_url($ext)
	{
		if (!preg_match('/^[a-z]+:\/\//i', $ext))
		{
			return self::clean('//' . self::$config->get('site', 'root_url') . '/' . self::$config->get('urls', 'externals') . '/' . $ext);
		}
		else
		{
			return self::clean($ext);
		}
	}

}
